.text					# Section for machine istructions to be executed
	.global _start			# Needed by ld to find his default entry point
_start:					# _start symbol
	pop %rax			# Put first 64 bits of stack in %rax register.
					# This is where the kernel loads the argument
					# count
	add $48, %rax			# Add "48" to %rax register.
					# We expect the argument count to be a number
					# between "1" and "9", so %rax + 48 = ASCII code
					# for decimal digit. To pass more than 8 cmd line
					# arguments is an error for this program
	push %ax			# Push to stack the content of the primary
					# accumulator %ax = lower 16 bits of %rax register
	movb $0x0A, 1(%rsp)		# Move 1 byte of data -the ASCII code for newline-
					# into memory at the address in %rsp register + 1
					# (byte). %rsp is the register that point at the
					# top of the stack (the stack pointer)
	mov $1, %rax			# Put "1" in %rax register. 1 = sys_write
	mov $1, %rdi			# Put "1" in %rdi register. 1 = stdout
	mov %rsp, %rsi			# Put address of the top of the stack in %rsi
					# register. This is the start address of the memory
					# region to write to file descriptor in %rdi register
	mov $2, %rdx			# Put "2" in %rdx register. 2 = number of bytes to write
	syscall				# Ask the kernel to perform syscall indexed by %rax

	mov	$60, %rax		# Put "60" in %rax register. 60 = sys_exit call
	xor	%rdi, %rdi		# Set %rdi register to "0". %rdi = where to put
					# exit status argument of sys_exit. Using the 'xor'
					# istruction is an optimization: avoid retrieving "0"
					# in memory)
	syscall				# Ask Linux to perform syscall indexed by %rax
